'This program lists files and folders for all drives.
'Files can either be printed or copied to the clipboard.
'For inclusion of folder icons, see PowerBasic posts 
'  http://www.powerbasic.com/support/forums/Forum4/HTML/005170.html  (Borje Hagsten)
'  http://www.powerbasic.com/support/forums/Forum4/HTML/001734.html  (Scott Turchin)
'[keywords] Listbox with folder icons, Owner drawn listbox, Status bar, Drives, Files and Folders
'-------------------------------------------------------------------------------------------------------------
#COMPILE EXE
#DIM ALL
'#INCLUDE "WIN32API.INC"
'#INCLUDE "comdlg32.inc"
'#INCLUDE "CommCtrl.inc"
#INCLUDE "ListFilesAPI.inc"
'#INCLUDE "debug.inc"
#RESOURCE "ListFiles.pbr" 'version number
%BMPMARGIN  = 2
%TEXTMARGIN = 36
$SPACE = SPACE$(8)
GLOBAL hDlg AS LONG
GLOBAL numFiles AS LONG 
GLOBAL showFiles AS LONG
GLOBAL copyMode AS LONG
GLOBAL hStatus AS LONG
GLOBAL hFolderIcon AS LONG
GLOBAL pd AS PRINTDLGAPI
GLOBAL files() AS STRING
$ver = "1.04"

FUNCTION PBMAIN
   LOCAL style AS LONG
   DIM files(10000) AS STRING
   DIALOG NEW 0, "Files and Folders - Ver " + $ver, , , 200, 220, %WS_SYSMENU TO hDlg
   style = %WS_TABSTOP OR %WS_VSCROLL OR %LBS_OWNERDRAWFIXED OR %LBS_HASSTRINGS
   CONTROL ADD LISTBOX, hDlg, 100, , 20, 20, 160, 130, style, %WS_EX_CLIENTEDGE
   CONTROL SEND hDlg, 100, %LB_SETITEMHEIGHT, 0, 20  '30
   CONTROL ADD BUTTON, hDlg, 101, "&Back", 20, 150, 50, 25
   CONTROL ADD BUTTON, hDlg, 102, "&Show", 75, 150, 50, 25
   CONTROL ADD BUTTON, hDlg, 103, "&Files", 130, 150, 50, 25
   setToolTipText hDlg, 101, "Back to parent folder or drive"
   setToolTipText hDlg, 102, "Show child folders and files"
   setToolTipText hDlg, 103, "List files for this folder"
   CONTROL ADD LABEL, hDlg, 104, "", 5, 10, 190, 9
   style = style OR %ES_MULTILINE OR %ES_WANTRETURN OR %ES_READONLY OR %ES_NOHIDESEL
   CONTROL ADD TEXTBOX, hDlg, 105, "", 20, 20, 160, 115, style, %WS_EX_CLIENTEDGE 
   CONTROL ADD BUTTON, hDlg, %IDOK, "", 0, 0, 0, 0, %BS_DEFAULT
   hStatus=CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL(%NULL), hDlg, 120)
   DIALOG SHOW MODAL hDlg, CALL mainDlgProc
END FUNCTION

CALLBACK FUNCTION mainDlgProc()
   LOCAL i AS LONG, j AS LONG, n AS LONG
   Local s As String, zTxt As Asciiz * 255, zPtr As Long, hLib As Long
   Local itd As Long, rc As RECT, lpdis As DRAWITEMSTRUCT Ptr
   STATIC sPath AS STRING, sFiles AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         numFiles = initListbox()
         FOR i = 1 TO numfiles 
            CONTROL SEND CBHNDL, 100, %LB_ADDSTRING, 0, STRPTR(files(i)) TO n
            CONTROL SEND CBHNDL, 100, %LB_SETITEMDATA, n, 1
         NEXT i
         LISTBOX SELECT CBHNDL, 100, 1
         CONTROL DISABLE CBHNDL, 101
         CONTROL SHOW STATE CBHNDL, 105, %SW_HIDE 
         zTxt = "SHELL32.DLL" 
         hLib = LoadLibrary(zTxt)
         IF hLib THEN
            hFolderIcon = LoadImage(BYVAL hLib, BYVAL 4, %IMAGE_ICON, 16, 16, 0)	
            FreeLibrary hLib
         END IF
         showFiles = 0
      CASE %WM_COMMAND            
         IF CBCTL = %IDOK OR CBCTL = 100 AND (CBCTLMSG = %LBN_SELCHANGE OR CBCTLMSG = %LBN_DBLCLK) THEN
            CONTROL SEND CBHNDL, 100, %LB_GETCURSEL, 0, 0 TO n
            CONTROL SEND CBHNDL, 100, %LB_GETITEMDATA, n, 0 TO j
            IF j = 0 AND LEN(sPath) THEN 'file selected
               CONTROL SET TEXT CBHNDL, 102, "Copy"
               setToolTipText CBHNDL, 102, "Copy full filename to clipboard"
               IF copyMode AND CBCTLMSG = %LBN_DBLCLK THEN
                  DIALOG SEND CBHNDL, %WM_COMMAND, 102, 0
               ELSE
                  copyMode = 1
               END IF
            END IF
            IF CBCTL = %IDOK OR (CBCTL = 100 AND CBCTLMSG = %LBN_DBLCLK) THEN 
               IF j THEN DIALOG SEND CBHNDL, %WM_COMMAND, 102, 0
            END IF 
         ELSEIF CBCTL = 101 THEN 'back to parent 
            showFiles = 0: copyMode = 0
            CONTROL SHOW STATE CBHNDL, 100, %SW_RESTORE 
            CONTROL SHOW STATE CBHNDL, 105, %SW_HIDE
            CONTROL SET TEXT CBHNDL, 102, "&Show"
            CONTROL SET TEXT CBHNDL, 103, "&Files"
            setToolTipText CBHNDL, 102, "Show child folders and files"
            setToolTipText CBHNDL, 103, "List files for this folder"  
            sPath = LEFT$(sPath, LEN(sPath) - 1)
            n = INSTR(-1, sPath, "\")
            IF n THEN
               zTxt = MID$(sPath, n + 1)
               sPath = LEFT$(sPath, n)
               numfiles = getFiles(sPath)
            ELSE
               CONTROL DISABLE CBHNDL, 101
               zTxt = sPath: sPath = "": numFiles = initListbox()
            END IF
            CONTROL SET TEXT CBHNDL, 104, sPath
            CONTROL SEND CBHNDL, 100, %LB_RESETCONTENT, 0, 0
            FOR i = 1 TO numfiles 
               s = files(i): j = 0: IF LEN(sPath) = 0 THEN j = 1
               IF LEFT$(s, 1) = CHR$(0) THEN j = hFolderIcon: s = MID$(s, 2) 'then a folder
               CONTROL SEND CBHNDL, 100, %LB_ADDSTRING, 0, STRPTR(s), TO n
               CONTROL SEND CBHNDL, 100, %LB_SETITEMDATA, n, j
            NEXT i
            CONTROL SEND CBHNDL, 100, %LB_FINDSTRINGEXACT, -1, VARPTR(zTxt) TO n
            CONTROL SEND CBHNDL, 100, %LB_SETCURSEL, n, 0
         ELSEIF CBCTL = 102 THEN 'show children
            IF showFiles THEN
               printFilesList(sPath)
            ELSEIF copyMode THEN                          
               copyMode = 0
               zPtr = VARPTR(zTxt)
               CONTROL SEND CBHNDL, 100, %LB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, 100, %LB_GETTEXT, n, zPtr
               s = sPath + zTxt: IF LEN(s) < 50 THEN s = s + SPACE$(50 - LEN(s))
               MSGBOX s, %MB_ICONINFORMATION, "Copied Full Filename to Clipboard"
               SetClipboardText(s) 
            ELSE
               zPtr = VARPTR(zTxt)
               CONTROL SEND CBHNDL, 100, %LB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, 100, %LB_GETTEXT, n, zPtr
               CONTROL SEND CBHNDL, 100, %LB_SETITEMDATA, n, j
               IF n >= 0 THEN
                  sPath = sPath + zTxt + "\" 
                  numFiles = getFiles(sPath) 
                  CONTROL SET TEXT CBHNDL, 104, sPath
                  CONTROL ENABLE CBHNDL, 101
                  CONTROL SEND CBHNDL, 100, %LB_RESETCONTENT, 0, 0
                  FOR i = 1 TO numfiles 
                     s = files(i): j = 0
                     IF LEFT$(s, 1) = CHR$(0) THEN j = hFolderIcon: s = MID$(s, 2) 'then a folder
                     CONTROL SEND CBHNDL, 100, %LB_ADDSTRING, 0, STRPTR(s), TO n
                     CONTROL SEND CBHNDL, 100, %LB_SETITEMDATA, n, j 
                  NEXT i
                  CONTROL SEND CBHNDL, 100, %LB_SETCURSEL, 0, 0
                  CONTROL SEND CBHNDL, 100, %LB_GETITEMDATA, 0, 0 TO j
                  IF j = 0 THEN
                     copyMode = 1 
                     CONTROL SET TEXT CBHNDL, 102, "Copy"
                     setToolTipText CBHNDL, 102, "Copy full filename to clipboard"
                  END IF
               END IF    
            END IF
         ELSEIF CBCTL = 103 THEN 'process files
            IF showFiles THEN
               s = "List of files sent to clipboard"
               MSGBOX s, %MB_ICONINFORMATION, "Folder: " + sPath
               CONTROL SEND CBHNDL, 105, %EM_SETSEL, 0, -1 
               s = "Folder: " + sPath + $CRLF
               FOR i = 1 TO numFiles 
                  s = s + $space + files(i) + $CRLF
               NEXT i
               SetClipboardText(s)
            ELSE
               showFiles = 1: CONTROL ENABLE CBHNDL, 101
               CONTROL SEND CBHNDL, 100, %LB_GETCURSEL, 0, 0 TO n 
               CONTROL SEND CBHNDL, 100, %LB_GETTEXT, n, VARPTR(zTxt)
               CONTROL SEND CBHNDL, 100, %LB_GETITEMDATA, n, 0 TO j
               CONTROL ENABLE CBHNDL, 101
               CONTROL SHOW STATE CBHNDL, 100, %SW_HIDE
               CONTROL SHOW STATE CBHNDL, 105, %SW_RESTORE 
               IF j THEN sPath = sPath + zTxt + "\"
               numFiles = getFiles(sPath): sFiles = ""
               CONTROL SET TEXT CBHNDL, 104, sPath
               CONTROL SEND CBHNDL, 100, %LB_RESETCONTENT, 0, 0
               FOR i = 1 TO numfiles
                  s = s + files(i) + $CRLF
               NEXT i
               CONTROL SET TEXT CBHNDL, 105, s 
               CONTROL SET TEXT CBHNDL, 102, "&Print List"
               CONTROL SET TEXT CBHNDL, 103, "&Copy List" 
               setToolTipText CBHNDL, 102, "Send file list to printer"
               setToolTipText CBHNDL, 103, "Send file list to clipboard"  
            END IF
         END IF
         IF CBCTL >= 101 AND CBCTL <= 103 THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE 
            CONTROL SET FOCUS CBHNDL, 100 
         END IF
      CASE %WM_DRAWITEM
        IF CBWPARAM = 100 THEN
           lpdis = CBLPARAM
           IF @lpdis.itemID = &HFFFFFFFF THEN EXIT FUNCTION
           SELECT CASE @lpdis.itemAction
              CASE %ODA_DRAWENTIRE, %ODA_SELECT
                 'CLEAR BACKGROUND
                 IF (@lpdis.itemState AND %ODS_SELECTED) = 0 THEN  'if not selected
                    FillRect(@lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_WINDOW))    'clear background
                    CALL SetBkColor(@lpdis.hDC, GetSysColor(%COLOR_WINDOW))                 'text background
                    CALL SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT))           'text color
                 ELSE
                    FillRect(@lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_HIGHLIGHT)) 'clear background
                    CALL SetBkColor(@lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT))              'text background
                    CALL SetTextColor(@lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT))        'text color
                 END IF
                 'DRAW TEXT
                 CONTROL SEND CBHNDL, 100, %LB_GETTEXT, @lpdis.itemID, VARPTR(zTxt)
                 rc = @lpdis.rcItem
                 rc.nLeft = %TEXTMARGIN
                 CALL DrawText(@lpdis.hDC, zTxt, LEN(zTxt), rc, %DT_SINGLELINE OR %DT_LEFT OR %DT_VCENTER)
                 'DRAW BITMAP
                 CONTROL SEND CBHNDL, 100, %LB_GETITEMDATA, @lpdis.itemID, 0 TO itd
                 IF itd THEN
                    CALL DrawState(@lpdis.hDC, 0&, 0&, itd, 0&, %BMPMARGIN, @lpdis.rcItem.ntop + 3, 0, 0, &H3)
                 END IF
                 FUNCTION = %TRUE : EXIT FUNCTION
           END SELECT
        END IF
   END SELECT
END FUNCTION

FUNCTION initListbox() AS LONG 
   LOCAL i AS LONG, n AS LONG, s AS STRING
   FOR i = 65 TO 90
      CHDRIVE CHR$(i)
      IF ERR = 0 THEN INCR n: files(n) = CHR$(i)+":" ELSE ERRCLEAR
   NEXT i
   s = STR$(n) + " drives"
   SendMessage hStatus, %SB_SETTEXT, 0, BYVAL STRPTR(s)
   FUNCTION = n
END FUNCTION 

FUNCTION getFiles(parent AS STRING) AS LONG
   'parent must be a folder 
   LOCAL attr AS LONG, attribute AS LONG, n AS LONG, i AS LONG 
   LOCAL s AS STRING, sLast AS STRING, notSorted AS LONG
   attr = %SUBDIR OR %READONLY OR %HIDDEN OR %SYSTEM
   s = DIR$(parent, attr): IF LEN(s) = 0 THEN FUNCTION = 0: EXIT FUNCTION 
   attribute = GETATTR(parent + s)
   IF BIT(attribute, 4) = 0 OR showFiles = 0 THEN
      IF BIT(attribute, 4) THEN s = CHR$(0) + s 'folder object
      IF s < sLast THEN notSorted = 1
      INCR n: files(n) = s: sLast = s
   END IF
   DO WHILE LEN(s)
      s = DIR$: IF LEN(s) = 0 THEN EXIT DO
      attribute = GETATTR(parent + s)
      IF BIT(attribute, 4) THEN 'folder object
         IF showFiles THEN ITERATE ELSE s = CHR$(0) + s
      END IF
      IF s < sLast THEN notSorted = 1
      INCR n: files(n) = s: sLast = s
   LOOP
   FOR i = n TO 1 STEP -1
      IF LEFT$(files(i), 1) = "~" THEN MID$(files(i), 1) = CHR$(1): notSorted = 1
   NEXT i
   IF notSorted THEN ARRAY SORT files(1) FOR n, COLLATE UCASE
   FOR i = 1 TO n
      IF LEFT$(files(i), 1) = CHR$(1) THEN MID$(files(i), 1) = "~" ELSE EXIT FOR
   Next i
   If showFiles Then s = "Files" Else s = "Objects" 
   s = STR$(n) + " " + s
   SendMessage hStatus, %SB_SETTEXT, 0, BYVAL STRPTR(s)
   FUNCTION = n
END FUNCTION



SUB printFilesList(folder AS STRING)
   LOCAL hPrinterDC AS LONG, di AS DOCINFO, tm AS TEXTMETRIC 
   LOCAL i AS LONG, y AS LONG, s AS STRING, charHt AS LONG
   LOCAL xDpi AS DOUBLE, yDpi AS DOUBLE, leftMargin AS DOUBLE, xDeadZone AS LONG
   LOCAL x1 AS LONG, x2 AS LONG, x3 AS LONG, dx AS LONG, yMax AS LONG
   LOCAL newPage AS LONG, prnErr AS LONG
   hPrinterDC = choosePrinter(0)
   GetTextMetrics hPrinterDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   xDpi = GetDeviceCaps(hPrinterDC, %LOGPIXELSX)/100  'x-pixels per .01 inch
   yDpi = GetDeviceCaps(hPrinterDC, %LOGPIXELSY)/100  'y-pixels per .01 inch
   xDeadZone = GetDeviceCaps(hPrinterDC, %PHYSICALOFFSETX)
   leftMargin = 50                          '0.50 inch left margin
   x1 = leftMargin * xDpi - xDeadZone
   dx = (850 * xDpi - 2 * x1) / 3           '8.50 inch width paper
   x2 = x1 + dx: x3 = x2 + dx
   IF hPrinterDC = 0 THEN GOTO wrapUp
   IF StartDoc(BYVAL hPrinterDC, di) <= 0 THEN prnErr = 2: GOTO wrapUp
   newPage = 1: yMax = 1000 * yDpi
   FOR i = 1 TO numFiles 
      IF newPage THEN
         IF StartPage(BYVAL hPrinterDC) <= 0 THEN prnErr = 3: GOTO wrapUp
         s = "Folder: " + folder: y = charHt
         TextOut hPrinterDC, x1, y, BYVAL STRPTR(s), LEN(s)
         y = y + 2 * charHt: newPage = 0
      END IF
      y = y + charHt
      s = files(i): TextOut hPrinterDC, x1, y, BYVAL STRPTR(s), LEN(s)
      IF y > yMax THEN EndPage hPrinterDC: newPage = 1
   NEXT i      
wrapUp:
   IF prnErr THEN 
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnErr)
   END IF
   EndPage hPrinterDC
   EndDoc hPrinterDC
   DeleteDC hPrinterDC
END SUB  

FUNCTION choosePrinter(landscape AS LONG) AS LONG
   'return printer device context for selected printer
   'landscape = 1  for landscape
   '          = 0  for portrait
   LOCAL pDevMode AS DEVMODE PTR, hPrnDC AS LONG
   pd.lStructSize = SIZEOF(pd)
   pd.hWndOwner = hDlg
   pd.Flags = %PD_RETURNDC OR %PD_NOSELECTION OR %PD_NOPAGENUMS OR %PD_HIDEPRINTTOFILE
   IF printDlg(pd) THEN
     hPrnDC = pd.hdc
     IF landscape THEN 
        pDevMode = GlobalLock(pd.hDevMode)
        @pDevMode.dmOrientation = %DMORIENT_LANDSCAPE
        ResetDC hPrnDC, BYVAL pDevMode
        GlobalUnlock pDevMode
     END IF
   END IF
   FUNCTION = hPrnDC
END FUNCTION

FUNCTION SetClipboardText (BYVAL sText AS STRING) AS LONG
   LOCAL hData AS DWORD, pData AS DWORD
'Create a global memory object and copy the data into it
   hData = GlobalAlloc(%GMEM_MOVEABLE OR %GMEM_DDESHARE, LEN(sText) + 1)
   pData = GlobalLock(hData)
   POKE$ pData, sText + CHR$(0) 
   GlobalUnlock hData
'Open the clipboard
   IF ISFALSE(OpenClipboard(%NULL)) THEN
      GlobalFree hData
      EXIT FUNCTION
   END IF
'Paste the data into the clipboard
   EmptyClipboard
   FUNCTION = SetClipboardData(%CF_TEXT, hData)
   CloseClipboard
END FUNCTION

SUB SetToolTipText(hDlg AS LONG, ctrl AS LONG, BYVAL txt AS STRING)
   'hDlg = handle of parent or owner window
   'ctrl = control id
   'txt  = text for tool tip
   '--------------------------------------------------------------------------------------------
   LOCAL nStyle AS LONG, ti AS TOOLINFO
   STATIC hToolTip AS LONG
   IF hToolTip = 0 THEN
      nStyle = %TTS_ALWAYSTIP  'add %TTS_BALLOON to style for balloon shape
      hToolTip = CreateWindowEx(BYVAL 0, "tooltips_class32", "", nStyle, 0, 0, 0, 0, BYVAL hDlg, _
                                BYVAL 0&, GetModuleHandle(BYVAL %NULL), BYVAL 0&)     
   END IF 
   DIALOG SEND hToolTip, %TTM_SETMAXTIPWIDTH, 0, 200               
   DIALOG SEND hToolTip, %TTM_SETDELAYTIME, %TTDT_AUTOPOP, 2500
   ti.cbSize   = LEN(ti)
   ti.uFlags   = %TTF_SUBCLASS OR %TTF_IDISHWND  
   ti.hWnd     = hDlg
   ti.uId      = GetDlgItem(hDlg, ctrl)
   ti.lpszText = STRPTR(txt)
   SendMessage hToolTip, %TTM_DELTOOL, 0, VARPTR(ti)
   SendMessage hToolTip, %TTM_ADDTOOL, 0, VARPTR(ti)
END SUB
                